"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ModalViewModule = void 0;

var _reactNative = require("react-native");

var Helpers = _interopRequireWildcard(require("./functions/helpers"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const moduleName = "ModalViewModule";
const NativeModule = _reactNative.NativeModules[moduleName];
const COMMAND_KEYS = {
  dismissModalByID: 'dismissModalByID',
  dismissAllModals: 'dismissAllModals'
};

class ModalViewModule {
  static dismissModalByID(modalID = '') {
    const promise = new Promise((resolve, reject) => {
      try {
        NativeModule[COMMAND_KEYS.dismissModalByID](modalID, success => {
          (success ? resolve : reject)();
        });
      } catch (error) {
        console.log("ModalViewModule, dismissModalByID error:");
        console.log(error);
        reject();
      }

      ;
    });
    return Helpers.promiseWithTimeout(1000, promise);
  }

  static dismissAllModals(animated = true) {
    const promise = new Promise((resolve, reject) => {
      try {
        NativeModule[COMMAND_KEYS.dismissAllModals](animated, success => {
          (success ? resolve : reject)();
        });
      } catch (error) {
        console.log("ModalViewModule, dismissAllModals error:");
        console.log(error);
        reject();
      }

      ;
    });
    return Helpers.promiseWithTimeout(1000, promise);
  }

}

exports.ModalViewModule = ModalViewModule;
;
//# sourceMappingURL=ModalViewModule.js.map