"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.EventEmitter = void 0;

class EventEmitter {
  constructor() {
    this._events = {};
  }

  addListener(eventKey, listener) {
    // initialize
    if (!this._events[eventKey]) {
      this._events[eventKey] = [];
    }

    ;

    this._events[eventKey].push(listener);
  }

  removeListener(eventKey, listenerToRemove) {
    // event does not exist
    if (!this._events[eventKey]) return;
    this._events[eventKey] = this._events[eventKey].filter(listener => listener !== listenerToRemove);
  }

  once(eventKey, listener) {
    this.addListener(eventKey, data => {
      listener === null || listener === void 0 ? void 0 : listener();
      this.removeListener(eventKey, listener);
    });
  }

  removeAllListeners() {
    this._events = {};
  }

  emit(eventKey, data) {
    // event does not exist
    if (!this._events[eventKey]) return;

    this._events[eventKey].forEach(callback => {
      callback === null || callback === void 0 ? void 0 : callback(data);
    });
  }

}

exports.EventEmitter = EventEmitter;
;
//# sourceMappingURL=EventEmitter.js.map